unit FDemo;
{Ce programme constitue une dmonstration des fonctions de l'unit
DriveEcran_Imprimante

La page de test comprend deux rgles, horizontales et verticales, qui permettent
de vrifier la prcision de la sortie  l'imprimante et aussi de vrifier
s'il faut modifier les marges de non impression de l'imprimante

Des textes, des rectangles, un trait, une image illustrent les diffrentes
fonctions et procdures

L'unit DriveEcran_Imprimante exige l'existence d'un PaintBox pour fonctionner
en particulier pour l'affichage de l'aperu avant impression. Pourtant la sortie
 l'imprimante ne s'en sert pas.

Si vous ne voulez pas vous servir de la sortie Ecran, Posez un PaintBox sur
votre fiche en attribuant false  sa proprit visible

Pour illustrer l'aperu avant impression le dplacement de la souris sur la page
fait s'afficher les coordonnes en x et y en cm ou en pixels si la touche Shift
est enfonce pendant le dplacement de la souris.

Le bouton Loupe agrandit l'aperu, le bouton Imprimer ouvre la boite de dialogue
d'impression qui vous permet de slectionner l'imprimante
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,  ExtCtrls, Printers, StdCtrls, Jpeg, DriveEcran_Imprimante,
  Menus, Buttons;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;    // l se dessinera l'aperu avant impression
    Button1: TButton;
    Image1: TImage;
    PrintDialog1: TPrintDialog;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    PrinterSetupDialog1: TPrinterSetupDialog;
    BtnImprimante: TButton;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure BtnImprimanteClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);  // Contiendra ou fera appel  la
                                                // routine d'afichage/impression
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    EnLoupe: boolean;                           // dfinit le mode d'affichage de
                                                // l'aperu  l'cran
    Procedure DessinePage(LaSortie: TPeripherique);   // Routine d'affichage/impression
    Procedure AfficheInfoImprimante;
  end;
    Procedure ImprimePage;

var
  Form1: TForm1;

implementation

uses FInfoImp;

{$R *.dfm}

Procedure ImprimePage;
Begin
   Form1.DessinePage(Imprimante);
End;

Procedure TForm1.AfficheInfoImprimante;
Begin
   With InfoImp, ParametresEcranImprimante do
      Begin
         EdHauteurPage.Text := FormatFloat('0.00',HauteurPapierImp)+' cm'; // Hauteur page en cm
         EdLargeurPage.Text := FormatFloat('0.00',LargeurPapierImp)+' cm'; // Largeur Page en cm
         EdHauteurImpression.Text := FormatFloat('0.00',HauteurImpression)+' cm'; // Hauteur Imprimable en cm
         EdLargeurImpression.Text := FormatFloat('0.00',LargeurImpression)+' cm'; // Largeur imprimable en cm
         EdMargeGauche.Text := FormatFloat('0.00',MargeImpGauche)+' cm'; // Marge gauche non imprimable
         EdMargeDroite.Text := FormatFloat('0.00',MargeImpDroite)+' cm'; // Marge droite non imprimable
         EdMargeHaute.Text := FormatFloat('0.00',MargeImpHaute)+' cm'; // Marge Haute non imprimable
         EdMargeBasse.Text := FormatFloat('0.00',MargeImpBasse)+' cm'; // Marge basse non imprimable
         EdPixelParPouceX.Text := IntToStr(PixelImpX)+' pixels/pouce'; // Rsolution horizontale imprimante en pixel/pouce
         EdPixelParPouceY.Text := IntToStr(PixelImpY)+' pixels/pouce'; // Rsolution verticale imprimante en pixel/pouce
         With Printer do
            begin
               NomImprimante.Caption := Printers[PrinterIndex]; // Nom de l'imprimante
            End;
      End;
End;

Procedure TForm1.DessinePage(LaSortie: TPeripherique);
Var
   i: Integer;   // pour les boucles
   x,            // pour les coordonnes en cm
   y,
   XFin,         // pour les coordonnes aprs affichage en cm
   YFin,
   L,            // Largeur de la page papier
   H: Real;      // Hauteur de la page papier

begin
   L := ParametresEcranImprimante.LargeurPapierImp;
   H := ParametresEcranImprimante.HauteurPapierImp;
   EPBrush(LaSortie,PaintBox1,ClWhite,BsSolid);  // Dfinit la couleur de fond en blanc plein
   EPPen(LaSortie,PaintBox1,ClBlack,0.1,PsClear); // Dfinit le contour  transparent
   EPRectangle(LaSortie,PaintBox1,0,0,L,H);   // trace un rectangle blanc sur toute la page
   {Dessine l'image contenue dans Image1 centre horizontalement sur 10,5 cm  3 centimtres
   du haut de page, avec une largeur de 16 cm. La hauteur sera automatiquement calcule}
   EPDessinOut(LaSortie,PaintBox1,10.5,3,16,0,Image1,JtCentre,JtHaut,XFin,YFin);
   EPPen(LaSortie,PaintBox1,ClGreen,0.2,PsSolid); // Dfinit le contour  un trait de 2mm vert plein
   EPBrush(LaSortie,PaintBox1,ClYellow,BsClear);  // Dfinit la couleur de fond  transparent
   EPRectangle(LaSortie,PaintBox1,10.5-(XFin-10.5),3,XFin,YFin); // Trace un rectangle autour de l'image
                                                                 // C'est au programmeur de calculer
                                                                 // les coordonnes !
   EPPen(LaSortie,PaintBox1,ClAqua,0,PsDash);  // Dfinit le trait vert d'eau en tirets
                                               // La taille 0 force l'paisseur  1 pixel qui est
                                               // la seule paisseur pour des traits diffrents de
                                               // la ligne continue
   EPLine(LaSortie,PaintBox1,10.5-(XFin-10.5),10.5,XFin,10.5); // Trace un trait en tirets sous l'image
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClMaroon,48,[FsBold,FsItalic]);  // dfinit la fonte  Brush Flair
                                                                            // couleur marron, 48 picas
                                                                            // gras et italique
   EPTextOut(LaSortie,PaintBox1,10.7,0.7,10.5,'Lzard des jardins',JtCentre,XFin,YFin); // Dessine l'ombre
                                                                                        //du titre
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClFuchsia,48,[FsBold,FsItalic]); // Change la couleur en Fuchsia
   EPTextOut(LaSortie,PaintBox1,10.5,0.5,10.5,'Lzard des jardins',JtCentre,XFin,YFin); // Dessine le titre
   y := 12;                 // Se place  12 cm du haut de page
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClRed,18,[FsBold, FsItalic]); // Ecrit le titre "justifi"
   EPTextOut(LaSortie,PaintBox1,2.8,11,7.4,'justifi',JtJustifie,XFin,YFin);
   EPFont(LaSortie,PaintBox1,'Arial',ClBlack,10,[FsBold]);  // Passe en Arial Gras noir
   For i := 0 to Memo1.Lines.Count-1 do   // Affiche les lignes contenues dans Memo1 en justifi
     Begin
       x := 2.8;
       EPTextOut(LaSortie,PaintBox1,x,y,7.4,Memo1.Lines[i],JtJustifie,XFin,YFin);
       y := YFin;     // passe  la ligne suivante
     End;
   EPBrush(LaSortie,PaintBox1,ClYellow,BsClear);    // Trace un rectangle autour du texte
   EPPen(LaSortie,PaintBox1,clBlack,0.04,PsSolid);
   EPRectangle(LaSortie,PaintBox1,2.6,11.8,XFin+0.2,YFin+0.2);
   y := 20.5;               // Se place  20.5 cm du haut de page
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClRed,18,[FsBold, FsItalic]); // Ecrit le titre " droite"
   EPTextOut(LaSortie,PaintBox1,10.3,19.5,7,'  d r o i t e',JtDroite,XFin,YFin);
   EPFont(LaSortie,PaintBox1,'Arial',ClBlack,10,[FsBold]);
   For i := 0 to Memo1.Lines.Count-1 do    // Affiche les lignes contenues dans Memo1 cales  droite
     Begin
       x := 10.3;
       EPTextOut(LaSortie,PaintBox1,x,y,7,Memo1.Lines[i],JtDroite,XFin,YFin);
       y := YFin;
     End;
   EPBrush(LaSortie,PaintBox1,ClYellow,BsClear);
   EPPen(LaSortie,PaintBox1,clBlack,0.04,PsSolid);
   EPRectangle(LaSortie,PaintBox1,5.9,20.3,XFin+0.2,YFin+0.2);
   y := 12;
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClRed,18,[FsBold, FsItalic]);
   EPTextOut(LaSortie,PaintBox1,12.5,11,7,'c e n t r ',JtCentre,XFin,YFin);
   EPFont(LaSortie,PaintBox1,'Arial',ClBlack,10,[FsBold]);
   For i := 0 to Memo1.Lines.Count-1 do    // Affiche les lignes contenues dans Memo1 centres
     Begin
       x := 12.5;
       EPTextOut(LaSortie,PaintBox1,x,y,7,Trim(Memo1.Lines[i]),JtCentre,XFin,YFin);
       y := YFin;
     End;
   EPBrush(LaSortie,PaintBox1,ClYellow,BsClear);
   EPPen(LaSortie,PaintBox1,clBlack,0.04,PsSolid);
   EPRectangle(LaSortie,PaintBox1,10.2,11.8,14.8,YFin+0.2);
   y := 20.5;
   EPFont(LaSortie,PaintBox1,'Brush Flair',ClRed,18,[FsBold, FsItalic]);
   EPTextOut(LaSortie,PaintBox1,14.8,19.5,7,'  g a u c h e',JtGauche,XFin,YFin);
   EPFont(LaSortie,PaintBox1,'Arial',ClBlack,10,[FsBold]);
   For i := 0 to Memo1.Lines.Count-1 do     // Affiche les lignes contenues dans Memo1 cales  gauche
     Begin
       x := 14.8;
       EPTextOut(LaSortie,PaintBox1,x,y,7,Trim(Memo1.Lines[i]),JtGauche,XFin,YFin);
       y := YFin;
     End;
   EPBrush(LaSortie,PaintBox1,ClYellow,BsClear);
   EPPen(LaSortie,PaintBox1,clBlack,0.04,PsSolid);
   EPRectangle(LaSortie,PaintBox1,14.6,20.3,19.2,YFin+0.2);
   EPPen(LaSortie,PaintBox1,clBlue,0.05,PsSolid);
   {Rgle horizontale}
   EPLine(LaSortie,PaintBox1,0,H-0.7,L,H-0.7);
   For i := 0 to Trunc(L) do
      Begin                              // Ecrit les chiffres de la rgle
         EPFont(LaSortie,PaintBox1,'Arial',clRed,10,[FsBold]);
         EPTextOut(LaSortie,PaintBox1,i,H-1.7,i,intToStr(i),JtCentre,XFin,YFin);
         EPLine(LaSortie,PaintBox1,i,H-1.2,i,H-0.7);  // Trace les lignes de cm
      End;
   For i := 0 to Round(L*10) do
      Begin
         EPLine(LaSortie,PaintBox1,i/10,H-0.95,i/10,H-0.7);  // Trace les lignes de mm
      End;
   For i := 0 to Trunc(L*2) do
      Begin
         EPLine(LaSortie,PaintBox1,i/2,H-1.1,i/2,H-0.7);    // Trace les lignes tous les 5 mm
      End;
   {Rgle verticale }
   EPLine(LaSortie,PaintBox1,1,0,1,H);
   For i := 0 to Trunc(H) do
      Begin
         EPFont(LaSortie,PaintBox1,'Arial',clRed,10,[FsBold]);   // Chiffres
         EPTextOut(LaSortie,PaintBox1,2,i-EPTextHeight(LaSortie,PaintBox1,'0')/2,2,intToStr(i),JtCentre,XFin,YFin);
         EPLine(LaSortie,PaintBox1,1,i,1.5,i);                   // cm
      End;
   For i := 0 to Round(H*10) do
      Begin
         EPLine(LaSortie,PaintBox1,1,i/10,1.25,i/10);    // mm
      End;
   For i := 0 to Round(H*2) do
      Begin
         EPLine(LaSortie,PaintBox1,1,i/2,1.40,i/2);      // 5 mm
      End;
   y := 12;
   EPFont(LaSortie,PaintBox1,'Arial',clOlive,14,[FsBold]);      // Titre des exemples de style
   EPTextOut(LaSortie,PaintBox1,15.2,y,0,'Exemples de texte :',JtGauche,XFin,YFin);
   y := Yfin+EPTextHeight(Imprimante,PaintBox1,'T');            // Saute deux lignes
   EPFont(LaSortie,PaintBox1,'Arial',clMaroon,14,[FsBold]);
   EPTextOut(LaSortie,PaintBox1,15.5,y,0,'Gras',JtGauche,XFin,YFin);   // Exemple de gras
   y := Yfin; // Ligne suivante
   EPFont(LaSortie,PaintBox1,'Arial',clMaroon,14,[FsBold,FsItalic]);
   EPTextOut(LaSortie,PaintBox1,15.5,y,0,'Gras It',JtGauche,XFin,YFin); // Exemple de gras italique
   EPTextOut(LaSortie,PaintBox1,XFin,y,0,'alique',JtGauche,XFin,YFin); // Exemple de gras italique
                                                                        // utilisant XFin
   y := Yfin;
   EPFont(LaSortie,PaintBox1,'Arial',clMaroon,14,[FsItalic]);   // Exemple d' italique
   EPTextOut(LaSortie,PaintBox1,15.5,y,0,'Italique',JtGauche,XFin,YFin);
   y := Yfin;
   EPFont(LaSortie,PaintBox1,'Arial',clMaroon,14,[FsUnderline]);  // Exemple de soulign
   EPTextOut(LaSortie,PaintBox1,15.5,y,0,'Soulign',JtGauche,XFin,YFin);
   y := Yfin;
   EPFont(LaSortie,PaintBox1,'Arial',clMaroon,14,[FsStrikeOut]);  // Exemple de barr
   EPTextOut(LaSortie,PaintBox1,15.5,y,0,'Barr',JtGauche,XFin,YFin);
   y := Yfin;
   EPFont(LaSortie,PaintBox1,'Arial',clWhite,14,[]);             // Exemple de surlign
   EPBrush(LaSortie,PaintBox1,ClAqua,BsSolid);                   // Dfinit la couleur du surlignement
   EPTextOut(LaSortie,PaintBox1,15.5,Y,0,'Surlign',JtGauche,XFin,YFin);
   If LaSortie = Ecran then  // Matrialise les marges non imprimable en jaune
      Begin
         EPBrush(LaSortie,PaintBox1,ClYellow,BsSolid);  // Dfinit la couleur de fond en jaune plein
         EPPen(LaSortie,PaintBox1,ClBlack,0.1,PsClear); // Dfinit le contour  transparent
         EPRectangle(LaSortie,PaintBox1,0,0,TalonGauche,H);   // trace un rectangle jaune sur la marge gauche
         EPRectangle(LaSortie,PaintBox1,0,0,L,TalonHaut);   // trace un rectangle jaune sur la marge haute
         EPRectangle(LaSortie,PaintBox1,0,H,L,H-TalonBas);   // trace un rectangle jaune sur la marge basse
         EPRectangle(LaSortie,PaintBox1,L-TalonDroit,0,L,H);   // trace un rectangle jaune sur la marge droite
      End;
End;

procedure TForm1.FormShow(Sender: TObject);
begin
//   EPCalculeCoeff(Ecran,EnLoupe);        // Initialise les coefficients : OBLIGATOIRE
//   EPCalculeCoeff(Imprimante,EnLoupe);
   AfficheInfoImprimante;
   PaintBox1.Top := ParametresEcranImprimante.TopApercu;                  // Initialise la position de l'aperu
   PaintBox1.Left := ParametresEcranImprimante.LeftApercu;         // pour une page A4
   PaintBox1.Width := ParametresEcranImprimante.LargeurApercu;
   PaintBox1.Height := ParametresEcranImprimante.HauteurApercu;
   Image1.Picture.LoadFromFile('Lzard.jpg');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   EnLoupe := not EnLoupe;               // Bascule de mode loupe  page entire
   EPCalculeCoeff(Ecran,EnLoupe);
   FormShow(Sender);                     // Redessine la fiche
   DessinePage(Ecran);                   // Redessine l'aperu
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Application.ShowHint := true;
   EnLoupe := false;                     // Dmarre en mode page entire
end;

procedure TForm1.Button2Click(Sender: TObject); // Lance l'impression
begin
{   If PrintDialog1.Execute then          // Lance le dialogue de slection imprimante
      Begin
         EPCalculeCoeff(Imprimante,false); // Recalcule le coeff en cas de modif de rsolution
         Printer.BeginDoc;              // Initialise l'impression
         DessinePage(Imprimante);       // envoie la page vers l'imprimante
         Printer.EndDoc;                // Termine l'impression
      End; }                            // REMPLACE PAR LA PROCEDURE EPIMPRIME.
   EPImprime(PrintDialog1,ImprimePage);  // Lance l'impression pilote par l'unit DriveEcran_Imprimante
                                       // La procedure d'impression ne doit contenir aucun paramtres
                                       // c'est pourquoi ImprimePage encapsule DessinePage(Imprimante) 
   Formshow(Sender);
   DessinePage(Ecran);                  // Ractulise l'aperu et les infos imprimante
   AfficheInfoImprimante;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);  // Utilis pour que la page se
                                                   // redessine automatiquement
begin
   DessinePage(Ecran);              // Envoie la page  l'cran
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin                    // Gre l'affichage des coordonnes dans le PaintBox
   If Shift <> [] then
      Begin
         Label1.Caption := 'X = '+IntToStr(X)+' pixels'; // affiche les coordonnes du
         Label2.Caption := 'Y = '+IntToStr(Y)+' pixels'; // curseur en cm sur la page
      End
   else
      Begin
         Label1.Caption := 'X = '+FormatFloat('0.00',X/CoeffEcran)+' cm'; // affiche les coordonnes du
         Label2.Caption := 'Y = '+FormatFloat('0.00',Y/CoeffEcran)+' cm'; // curseur en cm sur la page
      End;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin           // Efface les infos de coordonnes en dehors du PaintBox
   Label1.Caption := '';
   Label2.Caption := '';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   EPConfigImprimante(PrinterSetupDialog1,EnLoupe);  // Lance la configuration de
                     // l'impression. Procdure obligatoire pour l'aperu des textes
   FormShow(Sender);  // Ractualise la forme de l'aperu
   DessinePage(Ecran);
   AfficheInfoImprimante;
end;

procedure TForm1.BtnImprimanteClick(Sender: TObject);
begin
   InfoImp.Show; // Affiche les infos imprimantes, la configuration et l'impression
                 // La fiche reste active en dessous.  
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   Close;
end;

end.
